<?php
  @ini_set('default_charset', 'UTF-8');
  /*

  MyAge By Alessandro Marinuzzi [Alecos] © 2003-2020 - All Rights Reserved.
  Version: 1.7 - Data: 22.11.2020 - Release: Final
  Web: https://www.alecos.it/ - E-Mail: alecos@alecos.it
  This php script updates magically your age on your web pages.
  Optionally it's able to display a message for your BirthDay!
  This script is dedicated to my mother!

  */

  /* Don't change anything here below */

  function getmyage($my_birth, $my_set, $name = null) {
    $day = date('d');
    $year = date('Y');
    $month = date('m');
    if (isset($name)) {
      $name = htmlspecialchars($name, ENT_QUOTES | ENT_HTML401, 'UTF-8');
    }
    $found = 0;
    for ($i = 0; $i < strlen($my_birth); $i++) {
      if (preg_match('/[-]/', $my_birth[$i])) {
        $found++;
      }
    }
    if ($found != 2) {
      return "Error: unknown format!";
    }
    $temp_birth = explode('-', $my_birth);
    $my_day = $temp_birth[0];
    if (($my_day <= 0) || ($my_day > 31) || (!isset($my_day))) {
      return "Error: the day must be from 1 to 31!";
    }
    $day_digit = strlen($my_day);
    if (($day_digit <= 0) || ($day_digit > 2) || (!is_numeric($my_day))) {
      return "Error: the day must have min 1 digit and max 2 digits!";
    }
    $my_month = $temp_birth[1];
    if (($my_month <= 0) || ($my_month > 12) || (!isset($my_month))) {
      return "Error: the month must be from 1 to 12!";
    }
    $month_digit = strlen($my_month);
    if (($month_digit <= 0) || ($month_digit > 2) || (!is_numeric($my_month))) {
      return "Error: the month must have min 1 digit and max 2 digits!";
    }
    $my_year = $temp_birth[2];
    $year_digit = strlen($my_year);
    if (($year_digit <= 0) || ($year_digit > 4) || (!is_numeric($my_year)) || (!isset($my_year))) {
      return "Error: the year must have min 1 digit and max 4 digits!";
    }
    if ($my_year < 0) {
      return "Error: the year must not be less than zero!";
    }
    if ($my_year > $year) {
      return "Error: the BirthDay year must be less than current year!";
    }
    if (($my_set < 0) || ($my_set > 1) || (!isset($my_set))) {
      return "Error: the value for the BirthDay message must be 0 or 1!";
    }

    /* Adjust with your own values */

    $my_msg1 = "Today I turn " . ($year - $my_year) . " years!"; // Set the message for your BirthDay
    $my_msg2 = "Today $name turns " . ($year - $my_year) . " years!"; // Set the message for your BirthDay

    /* Don't change anything here below */

    if (($day == $my_day) && ($month == $my_month)) {
      $my_age = $year - $my_year;
      if ($my_set == 0) {
        $my_msg = false;
      } else {
        if (empty($name)) {
          echo "<script>alert(\"$my_msg1\");</script>";
        } else {
          echo "<script>alert(\"$my_msg2\");</script>";
        }
      }
    } elseif (($day >= $my_day) && ($month >= $my_month)) {
      $my_age = $year - $my_year;
    } elseif (($day < $my_day) && ($month == $my_month)) {
      $my_age = --$year - $my_year;
    } elseif (($day < $my_day) && ($month > $my_month)) {
      $my_age = $year - $my_year;
    } else {
      $my_age = --$year - $my_year;
    }
    return $my_age;
  }
?>