<?php
  @ini_set('default_charset', 'UTF-8');
  /*

  MyAge By Alessandro Marinuzzi [Alecos] © 2003-2020 - All Rights Reserved.
  Versione: 1.7 - Data: 22.11.2020 - Release: Finale
  Web: https://www.alecos.it/ - E-Mail: alecos@alecos.it
  Questo script php aggiorna magicamente la vostra età sulle vostre pagine web.
  Opzionalmente è in grado di mostrare un messaggio per il vostro Compleanno!
  Questo script è dedicato a mia madre!

  */

  /* Non cambiate nulla qui sotto */

  function getmyage($my_birth, $my_set, $name = null) {
    $day = date('d');
    $year = date('Y');
    $month = date('m');
    if (isset($name)) {
      $name = htmlspecialchars($name, ENT_QUOTES | ENT_HTML401, 'UTF-8');
    }
    $found = 0;
    for ($i = 0; $i < strlen($my_birth); $i++) {
      if (preg_match('/[-]/', $my_birth[$i])) {
        $found++;
      }
    }
    if ($found != 2) {
      return "Errore: formato sconosciuto!";
    }
    $temp_birth = explode('-', $my_birth);
    $my_day = $temp_birth[0];
    if (($my_day <= 0) || ($my_day > 31) || (!isset($my_day))) {
      return "Errore: il giorno deve essere da 1 a 31!";
    }
    $day_digit = strlen($my_day);
    if (($day_digit <= 0) || ($day_digit > 2) || (!is_numeric($my_day))) {
      return "Errore: il giorno deve avere minimo 1 cifra e massimo 2 cifre!";
    }
    $my_month = $temp_birth[1];
    if (($my_month <= 0) || ($my_month > 12) || (!isset($my_month))) {
      return "Errore: il mese deve essere da 1 a 12!";
    }
    $month_digit = strlen($my_month);
    if (($month_digit <= 0) || ($month_digit > 2) || (!is_numeric($my_month))) {
      return "Errore: il mese deve avere minimo 1 cifra e massimo 2 cifre!";
    }
    $my_year = $temp_birth[2];
    $year_digit = strlen($my_year);
    if (($year_digit <= 0) || ($year_digit > 4) || (!is_numeric($my_year)) || (!isset($my_year))) {
      return "Errore: l'anno deve avere minimo 1 cifra e massimo 4 cifre!";
    }
    if ($my_year < 0) {
      return "Errore: l'anno non deve essere inferiore allo zero!";
    }
    if ($my_year > $year) {
      return "Errore: l'anno del Compleanno deve essere inferiore all'anno corrente!";
    }
    if (($my_set < 0) || ($my_set > 1) || (!isset($my_set))) {
      return "Errore: il valore per il messaggio di Compleanno deve essere 0 oppure 1!";
    }

    /* Modificate con i vostri valori */

    $my_msg1 = "Oggi compio " . ($year - $my_year) . " anni!"; // Impostate il messaggio per il vostro Compleanno
    $my_msg2 = "Oggi $name compie " . ($year - $my_year) . " anni!"; // Impostate il messaggio per il vostro Compleanno

    /* Non cambiate nulla qui sotto */

    if (($day == $my_day) && ($month == $my_month)) {
      $my_age = $year - $my_year;
      if ($my_set == 0) {
        $my_msg = false;
      } else {
        if (empty($name)) {
          echo "<script>alert(\"$my_msg1\");</script>";
        } else {
          echo "<script>alert(\"$my_msg2\");</script>";
        }
      }
    } elseif (($day >= $my_day) && ($month >= $my_month)) {
      $my_age = $year - $my_year;
    } elseif (($day < $my_day) && ($month == $my_month)) {
      $my_age = --$year - $my_year;
    } elseif (($day < $my_day) && ($month > $my_month)) {
      $my_age = $year - $my_year;
    } else {
      $my_age = --$year - $my_year;
    }
    return $my_age;
  }
?>